import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import com.sun.image.codec.jpeg.*;

/*============================================================
Fractal class
It is a general class containing standard buttons. All fractals
inherit this basic capabiliity.
==============================================================*/
class Fractal extends Frame implements ActionListener,Runnable
{
	int i=0;
	String msg=null;
	
	//t :will be set by FractalMagic class on user pressing the button
	public Thread t=null;
	//main :a reference to calling class(FractalMagic) object
	FractalMagic main;
	
	//current height & width of frame
	int frameWidth, frameHeight;
	//add buttons 'save','settings','reset' 
	Button bsave,bsetting,breset,bquit;
	Label fractName;
	Fractal(FractalMagic f)
	{
		main=f;			//pointer to calling class object
	}	
	void setFractalName(String name)
	{	
		/*addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){dispose();System.exit(0);}}
		);*/
		setLayout(null);
		//create the buttons... and label
		fractName=new Label(name,Label.CENTER);
		bsave=new Button   ("Save");
		bsetting=new Button("Settings");
		breset=new Button  ("Reset");
		bquit=new Button  ("Quit");
		
		add(fractName);
		add(bsave);
		//add(bsetting);
		add(breset);
		add(bquit);
		bsave.addActionListener(this);
		bsetting.addActionListener(this);
		breset.addActionListener(this);
		bquit.addActionListener(this);
		
		fractName.setFont(new Font("ComicSans",Font.BOLD,18));
		fractName.setForeground(Color.blue);
		bsave.setForeground(Color.blue);
		bsetting.setForeground(Color.blue);
		breset.setForeground(Color.blue);
		bquit.setForeground(Color.blue);
		
		fractName.setBackground(Color.yellow);
		bsave.setBackground(Color.yellow);
		bsetting.setBackground(Color.yellow);
		breset.setBackground(Color.yellow);
		bquit.setBackground(Color.yellow);
						
		fractName.setBounds(0,10,frameWidth,40);
		bsave.setBounds(20,50,80,30);
		//bsetting.setBounds(20,85,80,30);
		breset.setBounds(20,85,80,30);
		bquit.setBounds(20,120,80,30);
	}
	
	//action to be performed on mouseclick of 'save' etc.
	public void actionPerformed(ActionEvent ae)
	{
		String str=ae.getActionCommand();
		if(str.equals("Save"))
		{	saveToFile();
		}
		else if(str.equals("Settings"))
		{	tuneSettings();
		}
		else if(str.equals("Reset"))
		{	resetDefaults();
		}
		else if(str.equals("Quit"))
		{	quit();
			//this.dispose();
			//main.setVisible(true);
		}
		repaint();
	}
	//to set size of frame initially
	public void Size(int xpos,int ypos,int w,int h)
	{
		frameWidth=w;
		frameHeight=h;
		setBounds(xpos,ypos,w,h);
		System.out.println("bounds in Size= "+getBounds());
	}
	//--------
	//function to be compulsorily overloaded by subclasses
	public void run(){}
	void saveToFile(){}
	void tuneSettings(){	msg="you pressed SETTINGS";}
	void resetDefaults(){msg="you pressed RESET";}
	void quit(){ }
	
	
	//--------
	
	void save(Image img)
	{	FileDialog fd = new FileDialog(main, "File Dialog", FileDialog.SAVE);
        fd.setLocation( 300, 300 );
        fd.setVisible(true);

        if( fd.getDirectory() == null || fd.getFile() == null )
        	return;

        String filename = fd.getDirectory();
        filename += fd.getFile();
        filename += ".jpg";

	    try{
           	FileOutputStream fo = new FileOutputStream(filename);
	       	JPEGImageEncoder jpge = JPEGCodec.createJPEGEncoder(fo);
	       	BufferedImage bi = new BufferedImage(800,600,BufferedImage.TYPE_INT_RGB);
	
	        bi.getGraphics().drawImage(img,0,0,this);
	      	jpge.encode( bi );
	        fo.close();
        }
	     catch( Exception ex ){System.out.println("Hello");}
    }
	/*public void paint(Graphics g)
	{
		//g.drawString(msg,100,200);
		//g.drawString(Integer.toString(i),5*i,200);
	}*/

}