import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class Jpark extends Fractal
{
	int minLen;
	boolean flag;
	Image jimg;
	Graphics gr;
	Graphics g;
	Thread t=null;
	int type=1,count=0;
	Button bt1,bt2,bt3;
	Jpark(FractalMagic f)
  	{
		super(f);

	}
	public void initialize()
	{
		jimg=null;
		jimg=this.createImage(800,600);
		gr=jimg.getGraphics();
		g=this.getGraphics();
		
		setFractalName("Jurassic Park Fractal");
		
		bt1=new Button("Type 1");
		bt2=new Button("Type 2");
		bt3=new Button("Type 3");
		
		add(bt1);
		add(bt2);
		add(bt3);
		
		bt1.addActionListener(this);
		bt2.addActionListener(this);
		bt3.addActionListener(this);
		
		bt1.setForeground(Color.blue);
		bt2.setForeground(Color.blue);
		bt3.setForeground(Color.blue);
		
		bt1.setBackground(Color.yellow);
		bt2.setBackground(Color.yellow);
		bt3.setBackground(Color.yellow);
		
		bt1.setBounds(20,this.getHeight()-50,80,30);
		bt2.setBounds(120,this.getHeight()-50,80,30);
		bt3.setBounds(220,this.getHeight()-50,80,30);
			
	}
	public void actionPerformed(ActionEvent ae)
	{
		super.actionPerformed(ae);
		String str=ae.getActionCommand();
		if(str.equals("Type 1"))
		{	type=1;
		}
		else if(str.equals("Type 2"))
		{	type=2;
		}
		else if(str.equals("Type 3"))
		{	type=3;
		}
		resetDefaults();	
	}
	public void run()
	{//	int minLen;
		boolean prevflag=flag;
		/*try {Thread.currentThread().sleep(5000);}
				catch (InterruptedException e) { }	*/
	  while(true)				//only way to get out is thru Quit button
	  {	
	  	for(minLen=1024;minLen>1;minLen=minLen/2,count=0)
		{
			if(type==1)fract(200,340,200+350,340);
			if(type==2)fract(130,150,130+450,150);
			if(type==3)fract(130,150,130+450,150);
			
			System.out.println("No. of calls :"+count);
			
			while(flag==prevflag)
			{	try {Thread.currentThread().sleep(10);}
				catch (InterruptedException e) { }	
			}
			prevflag=flag;
			
			System.out.println("minLen ="+minLen);
			gr.clearRect(0,0,800,600);
			g.clearRect(0,0,800,600);
		}
	  }
	}
	
	public boolean mouseDown (Event e, int x, int y)
	{	flag=!flag;	
		System.out.println("Flag ="+flag);
		return true;
	}
	
	/*public void paint(Graphics g)
	{	//g.drawImage(clearRect(0,50,800,600);
		if(jimg!=null)g.drawImage(jimg,0,0,Color.cyan,this);	
	}*/
	void fract(int x1,int y1,int x2,int y2)
	{	
		int off;
		int temp;
		
		count++;
		if(y1==y2)
		{	if(x1>x2){	temp=x1;x1=x2;x2=temp;	};
			off=x2-x1;
			if(off<minLen)
			{	//for storing in image
				gr.setColor(Color.blue);
				gr.drawLine(x1,y1,x2,y2);
				//to display on screen
				g.setColor(Color.blue);
				g.drawLine(x1,y1,x2,y2);
				
				
				//System.out.println(x1+","+y1+","+x2+","+y2);
				return ;
			}
			off=off/2;
			if(type==1)
			{	fract(x1,y1,x1,y1-off);
				fract(x1,y1-off,x1+off,y1-off);
				fract(x1+off,y1-off,x1+off,y1);
			}
			if(type==2)
				fract(x1,y1,x1+off,y1);
			if(type==3)
			{	fract(x1,y1,x1+off,y1);
				fract(x1+off,y1,x2,y2);
			}
			fract(x1+off,y1,x1+off,y1+off);
			fract(x1+off,y1+off,x2,y1+off);
			fract(x2,y1+off,x2,y1);
		}
		if(x1==x2)
		{
			if(y1>y2){	temp=y1;y1=y2;y2=temp;	};
			off=y2-y1;
			if(off<minLen)
			{	//to store in image
				gr.setColor(Color.black);
				gr.drawLine(x1,y1,x2,y2);
				//to display on screen
				g.setColor(Color.black);
				g.drawLine(x1,y1,x2,y2);
				return ;
			}
			off=off/2;
			
			if(type==1)
			{	fract(x1,y1,x1+off,y1);
				fract(x1+off,y1,x1+off,y1+off);
				fract(x1+off,y1+off,x1,y1+off);
			}
			if(type==2)
				fract(x1,y1,x1,y1+off);
			if(type==3)
			{	fract(x1,y1,x1,y1+off);
				fract(x1,y1+off,x2,y2);
			}
			fract(x1,y1+off,x1-off,y1+off);
			fract(x1-off,y1+off,x1-off,y2);
			fract(x1-off,y2,x1,y2);
		}
	}
	void tuneSettings()
	{			}
	void saveToFile(){	save(jimg);	}
	void quit(){	this.dispose();main.setVisible(true);}	
	void resetDefaults()
	{	
		minLen=1024;
		jimg=null;
		jimg=this.createImage(800,600);
		gr=jimg.getGraphics();
		if(type==1)fract(200,340,200+350,340);
		if(type==2)fract(130,150,130+450,150);
		if(type==3)fract(130,150,130+450,150);
	}
}