import java.awt.*;
import java.applet.*;

public class Tree extends Fractal
{
  	double mxx,myy,bxx,byy;
  	Image timg;
  	Graphics gr;
  	Tree(FractalMagic f)
  	{	super(f);  	}
  	public void initialize()
  	{
  		setFractalName("Tree Fractal");
  		breset.setVisible(false);
  		
  		timg=this.createImage(800,600);
  		gr=timg.getGraphics();
  	}
  	public void run()
  	{
  		Treeplot();
  	}
  	public void Treeplot()
  	{	int i,max;
    	int pex,pey;	//the target point to be calculated at each iteration
    	double x,y,r,xn,yn;

	    max=30000;
    	x=0.0;                 /* initial position */
    	y=0.0;
    
    	coormundo(-0.8,1.8,0.8,0.0);		//sets mxx,myy,bxx,byy
    	
    	gr.setColor(Color.black);
    	gr.fillRect(0,0,650,550);
    	gr.setColor(Color.green);
    	for(i=1 ; i<=max; i++)
    	{
      		r=Math.random();
      		if (r<=0.1)
      		{	xn = 0.05*x;
         		yn = 0.6*y;
      		}
      		else if((r>0.1) && (r<0.2))
      		{   xn  = 0.05*x;
         		yn  = -0.5*y+1.0;
      		}
      		else if ((r>0.2) && (r<0.4))
      		{   xn  = 0.46*x-0.32*y;
         		yn  = 0.39*x+0.38*y+0.6;
      		}  
      		else if((r>0.4) && (r<0.6))
      		{   xn  = 0.47*x-0.15*y;
         		yn  = 0.17*x+0.42*y+1.1;
      		}
      		else if ((r>0.6) && (r<0.8))
      		{   xn  = 0.43*x+0.28*y;
         		yn  = -0.25*x+0.45*y+1.0;
      		}  
      		else 
      		{   xn  = 0.42*x+0.26*y;
         		yn  = -0.35*x+0.31*y+0.7;
      		}  
      		x = xn;
      		y = yn;
	  		pex=(int)(mxx*x+bxx);
      		pey=(int)(myy*y+byy);
      		gr.drawLine(pex,pey,pex,pey);
      		if(i<28000)gr.setColor(Color.green);
      		if((i>28000)&&(i<29000))gr.setColor(Color.yellow);
      		if(i>29000)gr.setColor(Color.orange);
    	}
  	}//end of Treeplot
  	void coormundo(double xiz,double ysu,double xde,double yinf)
  	{
    	double maxx,maxy,xxfin,xxcom,yyin,yysu;
    	maxx=600;
    	maxy=450;
    	xxcom=0.15*maxx;
    	xxfin=0.75*maxx;
    	yyin=0.8*maxy;
    	yysu=0.2*maxy;
    	mxx=(xxfin-xxcom)/(xde-xiz);
    	bxx=0.5*(xxcom+xxfin-mxx*(xiz+xde));
    	myy=(yyin-yysu)/(yinf-ysu);
    	byy=0.5*(yysu+yyin-myy*(yinf+ysu));
  	}
  	public void paint(Graphics g)
	{
		if(timg!=null)g.drawImage(timg,0,0,this);
	}
	void tuneSettings()
	{			}
	void saveToFile(){	save(timg);	}
	void quit(){	this.dispose();main.setVisible(true);}	
	void resetDefaults()
	{	
		timg=this.createImage(800,600);
		gr=timg.getGraphics();		
	}
}        
